
AWSTemplateFormatVersion: 2010-09-09
Description: >-
  AWS CloudFormation VPC for mongo infra


Parameters:
  VpcCidrBlock:
    Type: String
    Default: 10.1.0.0/16
    Description: Enter the main VPC CIDR block.


Resources:
#Creation du VPC et des subnets
  MyVPC:
    Type: AWS::EC2::VPC
    Properties:
      CidrBlock: !Ref VpcCidrBlock
      Tags:
        - Key: Name
          Value: 'mongo-VPC'

  PublicSubnetA:
    Type: AWS::EC2::Subnet
    Properties:
      MapPublicIpOnLaunch : true
      AvailabilityZone: !Select [ 0, Fn::GetAZs: !Ref 'AWS::Region']
      CidrBlock: !Select [ 1, !Cidr [ !GetAtt MyVPC.CidrBlock, 2, 8 ] ]
      Tags:
        - Key: Name
          Value: 'mongo-public-a'
      VpcId: !Ref MyVPC

#Creation de l'internet Gateway du VPC
  InternetGateway:
    Type: AWS::EC2::InternetGateway
    Properties:
      Tags:
        - Key: Name
          Value: 'mongo-InternetGateway'

  AttachInternetGateway:
    Type: AWS::EC2::VPCGatewayAttachment
    Properties:
      VpcId: !Ref MyVPC
      InternetGatewayId: !Ref InternetGateway

#Creation Tables-routage-PublicA et routes
  PublicRouteTable:
    Type: AWS::EC2::RouteTable
    Properties:
      VpcId: !Ref MyVPC
      Tags:
        - Key: Name
          Value: MainVPC-route-public-a

  AttachPublicRouteTable:
    Type: AWS::EC2::SubnetRouteTableAssociation
    Properties:
      RouteTableId: !Ref PublicRouteTable
      SubnetId: !Ref PublicSubnetA

  routeIPv4A:
    Type: AWS::EC2::Route
    Properties:
      DestinationCidrBlock: 0.0.0.0/0
      GatewayId: !Ref InternetGateway
      RouteTableId: !Ref PublicRouteTable

  routeIPv6A:
    Type: AWS::EC2::Route
    Properties:
      DestinationIpv6CidrBlock: ::/0
      GatewayId: !Ref InternetGateway
      RouteTableId: !Ref PublicRouteTable


Outputs:
  VPC:
    Description: The ID of the VPC
    Value: !Ref MyVPC
    Export:
      Name: !Sub "${AWS::StackName}-vpc-id"
  CidrBlockVPC:
    Description: The ID of the VPC
    Value: !GetAtt MyVPC.CidrBlock
    Export:
      Name: !Sub "${AWS::StackName}-vpc-cidr"
  PublicSubnets:
    Description: List of public subnets ID
    Value: !Ref PublicSubnetA
    Export:
      Name: !Sub "${AWS::StackName}-subnet-public-id"
